/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.mq;

import java.io.IOException;
import java.io.PrintWriter;
import java.security.Principal;
import java.util.Iterator;
import java.util.Properties;
import java.util.Set;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.security.auth.Subject;
import javax.security.auth.login.LoginContext;
import javax.security.auth.login.LoginException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import mq.com.TestSessionRemote;

/**
 *
 * @author gaurav
 */
public class ClientServlet extends HttpServlet {
   
    /** 
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException, LoginException, NamingException {
        response.setContentType("text/html;charset=UTF-8");
        PrintWriter out = response.getWriter();
        try {
            /** TODO output your page here
            out.println("<html>");
            out.println("<head>");
            out.println("<title>Servlet ClientServlet</title>");  
            out.println("</head>");
            out.println("<body>");
            out.println("<h1>Servlet ClientServlet at " + request.getContextPath () + "</h1>");
            out.println("</body>");
            out.println("</html>");
            */

            String userName = "gaurav";
            String password = "gaurav";
            Subject subject;

            /**
                * During the login process(i.e. when the login() method on the LoginContext is called),
                * the control will be transferred to a CallbackHandler. The CallbackHandler will be
                * responsible for populating the Callback object with the username and password, which
                * will be later on used by the login process
                *
                * The "MyCallbackHandler" is your own class and you can give any name to it. MyCallbackHandler
                * expects the username and password to be passed through its constructor, but this is NOT
                * mandatory when you are writing your own callback handler.
                *
                *
                */
            MyCallbackHandler handler = new MyCallbackHandler(userName,password);


             /**
     * Create a login context. Here, as the first parameter, you will specify which
     * configuration(mentioned in the "authFile" above) will be used. Here we are specifying
     * "someXYZLogin" as the configuration to be used. Note: This has to match the configuration
     * specified in the someFilename.someExtension authFile above.
     * The login context expects a CallbackHandler as the second parameter. Here we are specifying
     * the instance of MyCallbackHandler created earlier. The "handle()" method of this handler
     * will be called during the login process.
     */
            LoginContext lc = new LoginContext("PassAuth",handler);

            /**
             * Do the login
             */
            try {
                 lc.login();
                 subject = lc.getSubject();
                 System.out.println("value of subject is "+subject.toString());
            } catch(LoginException e) {
                System.out.println("authentication failed");
                e.printStackTrace();
            }

            Set<Principal> pricipalSet =
            lc.getSubject().getPrincipals();

            Iterator iterator = pricipalSet.iterator();
            System.out.println("Principal = ");

        while(iterator.hasNext()) {
         Principal principal = (Principal) iterator.next();
         System.out.println(""+principal.getName());
        }//while()


            

            System.out.println("Successfully logged in user: " + userName);


            TestSessionRemote testSessionRemote = myMethod();
            System.out.println("session bean value returned as " + testSessionRemote);
            System.out.println("values from bean is : " + testSessionRemote.addition());
            lc.logout();
        } 
        finally {

            out.close();
        }
    } 

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /** 
     * Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        try {
            processRequest(request, response);
        } catch (LoginException ex) {
            Logger.getLogger(ClientServlet.class.getName()).log(Level.SEVERE, null, ex);
        } catch (NamingException ex) {
            Logger.getLogger(ClientServlet.class.getName()).log(Level.SEVERE, null, ex);
        }
    } 

    /** 
     * Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        try {
            processRequest(request, response);
        } catch (LoginException ex) {
            Logger.getLogger(ClientServlet.class.getName()).log(Level.SEVERE, null, ex);
        } catch (NamingException ex) {
            Logger.getLogger(ClientServlet.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    /** 
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

    public static TestSessionRemote myMethod() throws NamingException
    {
        Properties p = new Properties();
       p.put("java.naming.factory.initial","org.jnp.interfaces.NamingContextFactory");
       p.put("java.naming.provider.url","jnp://localhost:1099");
       p.put("java.naming.factory.url.pkgs","org.jboss.naming:org.jnp.interfaces");

//       Properties p = new Properties();
      // Try with a login that should succeed
//      p.setProperty(Context.INITIAL_CONTEXT_FACTORY, "org.jboss.security.jndi.LoginInitialContextFactory");
//      p.setProperty(Context.PROVIDER_URL, "jnp://localhost:1099/");
//      p.setProperty(Context.SECURITY_CREDENTIALS, "theduke");
//      env.setProperty(Context.SECURITY_PRINCIPAL, "jduke");
//      env.setProperty(Context.SECURITY_PROTOCOL, "testLoginInitialContext");
//       p.put("java.naming.factory.initial","org.jnp.interfaces.NamingContextFactory");
//       	p.put("java.naming.provider.url","localhost:1099");
//        p.put("java.naming.factory.url.pkgs","=org.jboss.naming:org.jnp.interfaces");

      InitialContext context = new InitialContext(p);

    //lookup the home object
   return (TestSessionRemote)context.lookup("Tr");
//    FirstEjb home = (FirstEjb) PortableRemoteObject.narrow(lookupObj, FirstEjb.class);

    //create the bean object from the home object
//    FirstEjb myBean = home.addition();

    //invoke the method on the bean

    }

}
